#include "Class1.h"
#include "Module1.h"
#include<string>
#include <stdio.h>
#include <stdlib.h>

#include <iostream>
#include <vector>

using namespace SG_SDK_SBIS_CPP;
using namespace System;
using namespace std;

Class1::Class1()
{
		this->serialPort1->PortName = "COM7";
		this->serialPort1->BaudRate = 38400;
		this->serialPort1->Parity = System::IO::Ports::Parity::None;
		this->serialPort1->DataBits = 8;
		this->serialPort1->StopBits = System::IO::Ports::StopBits::One;
		this->serialPort1->Handshake = System::IO::Ports::Handshake::None;
		this->serialPort1->NewLine = "\r\n";
}

void MarshalString(String ^ s, string& os) {
	using namespace Runtime::InteropServices;
	const char* chars =
		(const char*)(Marshal::StringToHGlobalAnsi(s)).ToPointer();
	os = chars;
	Marshal::FreeHGlobal(IntPtr((void*)chars));
}


std::vector<std::string> split(std::string str, char del) {
	unsigned int first = 0;
	int last = str.find_first_of(del);

	std::vector<std::string> result;

	while (first < str.size()) {
		std::string subStr(str, first, last - first);

		result.push_back(subStr);

		first = last + 1;
		last = str.find_first_of(del, first);

		if (last == std::string::npos) {
			last = str.size();
		}
	}

	return result;
}


//Connect
bool Class1::Connect()
{
	String^ buf1 = "#CONNECT:";
	String^ buf2;
	String^ buf3;

	try
	{
		if (this->serialPort1->IsOpen == false)
		{
			this->serialPort1->Open();				//Port Open
			this->serialPort1->WriteLine(buf1);		//Send #CONNECT:
			Threading::Thread::Sleep(50);
			buf2 = this->serialPort1->ReadLine();	//Recive
			if (buf2[0] == 'O' && buf2[1] == 'K')	//Check the recive data
			{
				Module1::DeviceCount = (int)buf2[2];	//Decice count
				buf3 = buf2[2].ToString();
				Module1::DeviceCount = Int32::Parse(buf3);	//Decice count

				Module1::DeviceCount = 3;	//DBG

				this->Wait_Ready();
			}
			else
			{
				throw new exception;
			}
			
		}
	}
	catch (...)
	{
		this->serialPort1->Close();
		return false;
	}
	return true;
}

//Disconnect
bool Class1::Disconnect()
{
	try
	{
		this->serialPort1->Close();	//Port Close
	}
	catch (...)
	{
		return false;
	}
	return true;
}

//Get Speed
bool Class1::GetSpeed(int DevNo, String^& speed)

{
	String^ buf1;
	String^ buf2;
	char del = ',';
	std::string str; 
	string sss[30];
	int i=0;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "?:D," + (DevNo).ToString() + ",D";
			this->serialPort1->WriteLine(buf1);			//Send ? command
			Threading::Thread::Sleep(50);
			buf2 = this->serialPort1->ReadLine();		//Recive

			MarshalString(buf2, str);
			for (const auto subStr : split(str, del)) {
				sss[i] = subStr;
				i += 1;
			}
			str = "S" + sss[0] + "F" + sss[1] + "R" + sss[2] + '\0';
			speed = gcnew String(str.c_str());
		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		speed = "";
		return false;
	}
	return true;
}

//Get recive data
String^ Class1::Get_Value(int Num)
{
	int i,j;
	String^ buf1;
	String^ rtn="";
	char del = ',';
	std::string str;
	string sss[30];

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			for (i = 1; i <= Num; i++)
			{
				System::Windows::Forms::Application::DoEvents();
				buf1 = this->serialPort1->ReadLine();			//Recive
				MarshalString(buf1, str);
				j = 0;
				for (const auto subStr : split(str, del)) {
					sss[j] = subStr;
					j += 1;
				}
				rtn = rtn + gcnew String(sss[2].c_str());
				if (Num != 1 && i != Num)
				{
					rtn = rtn + ",";
				}

			}

		}
		else
		{
			throw new exception;
		}
	}
	catch (...)
	{
		return "";
	}
	return rtn;
}

//Wait to Ready
bool Class1::Wait_Ready()
{
	String^ buf1;
	String^ buf2;
	char del = ',';
	std::string str;
	string sss[30];
	int i,j;


	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			WR_Doing = true;
			do
			{
				System::Windows::Forms::Application::DoEvents();
				if (Stop_Flg == true)
				{
					this->serialPort1->DiscardInBuffer();			//Clear buffer
					buf1 = "LE:A";
					this->serialPort1->WriteLine(buf1);				//Send LE:A command
					Threading::Thread::Sleep(50);
					buf2 = this->Get_Value(Module1::DeviceCount);	//Recive OK
					break;
				}

				this->serialPort1->DiscardInBuffer();				//Clear buffer
				buf1 = "Q:A";
				this->serialPort1->WriteLine(buf1);					//Send Q command
				Threading::Thread::Sleep(50);
				buf2 = this->Get_Value(Module1::DeviceCount);		//Recive status
				MarshalString(buf2, str);
				j = 0;
				for (const auto subStr : split(str, del)) {
					sss[j] = subStr;
					j += 1;
				}
				j = 0;
				for (i = 0; i <= 2; i++)
				{
					if (Module1::pCheckBoxEnable[i]->Checked == true)
					{
						Module1::pLabel_Position[i]->Text = gcnew String(sss[j].c_str());	//Show coordinate
						j += 1;
					}
				}

				System::Windows::Forms::Application::DoEvents();
				this->serialPort1->DiscardInBuffer();				//Clear buffer
				buf1 = "!:A";
				this->serialPort1->WriteLine(buf1);					//Send ! command
				Threading::Thread::Sleep(50);
				buf2 = this->Get_Value(Module1::DeviceCount);		//Recive status
				MarshalString(buf2, str);
				j = 0;
				for (const auto subStr : split(str, del)) {
					sss[j] = subStr;
					j += 1;
				}
				j = 0;
				for (i = 0; i <= Module1::DeviceCount - 1; i++)
				{
					if (sss[i] == "R")	//Check Ready
					{
						j += 1;
					}
				}
				if (j == Module1::DeviceCount)
				{
					break;
				}


			} while (true);
						
		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		return false;
	}
	finally
	{
		Stop_Flg = false;
		WR_Doing = false;
	}
	return true;
}

//Return Origen
bool Class1::ReturnOrigin()
{
	String^ buf1;
	String^ buf2;
	int i;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "H:D";
			buf2 = Module1::DeviceString();
			if (buf2 == "")
			{
				throw new exception;
			}
			buf1 = buf1 + buf2;
			this->serialPort1->WriteLine(buf1);				//Send H command
			Threading::Thread::Sleep(50);

			buf2 = "";
			buf2 = this->serialPort1->ReadLine();			//Recive
			i = 4 + (2 * (Module1::DeviceCount - 1));
			buf1 = buf2->Substring(i, 2);
			if (buf1 != "OK")
			{
				throw new exception;
			}

			Threading::Thread::Sleep(2500);
			this->Wait_Ready();		//Show current position
		}
		else
		{
			throw new exception;
		}
	}
	catch (...)
	{
		return false;
	}
	return true;
}

//Set Speed
bool Class1::SetSpeed(std::string Speed[])
{
	String^ buf1;
	String^ buf2;
	int i;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "D:D";
			for (i = 0; i <= 2; i++)
			{
				if (Module1::pCheckBoxEnable[i]->Checked == true)
				{
					buf1 = buf1 + "," + (i + 1).ToString() + "," + gcnew String(Speed[0].c_str()) + "," + gcnew String(Speed[1].c_str()) + "," + gcnew String(Speed[2].c_str());
				}
			}
			this->serialPort1->WriteLine(buf1);				//Send D command
			Threading::Thread::Sleep(50);
			buf2 = this->Get_Value(Module1::DeviceCount);	//Recive OK
		}
		else
		{
			throw new exception;
		}
	}
	catch (...)
	{
		return false;
	}
	return true;
}

//Stop
bool Class1::StopStage()
{
	String^ buf1;
	String^ buf2;
	int i;

	if (WR_Doing == true)	//Already doing
	{
		Stop_Flg = true;
		return true;
	}

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "L:D";
			for (i = 0; i <= 2; i++)
			{
				if (Module1::pCheckBoxEnable[i]->Checked == true)
				{
					buf1 = buf1 + "," + (i + 1).ToString();
				}
				this->serialPort1->WriteLine(buf1);				//Send L command
				Threading::Thread::Sleep(50);
				buf2 = this->Get_Value(Module1::DeviceCount);	//Recive OK

				Threading::Thread::Sleep(1500);
				this->Wait_Ready();		//Show current position
			}
		}
		else
		{
			throw new exception;
		}
	}
	catch (...)
	{
		return false;
	}
	return true;
}

//Stop Emergency
bool Class1::StaopStageEmergency()
{
	String^ buf1;
	String^ buf2;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "EL:A";
			this->serialPort1->WriteLine(buf1);				//Send L command
			Threading::Thread::Sleep(50);
			buf2 = this->Get_Value(Module1::DeviceCount);	//Recive OK

			Threading::Thread::Sleep(2500);
			this->Wait_Ready();		//Show current position
		}
		else
		{
			throw new exception;
		}
	}
	catch (...)
	{
		return false;
	}
	return true;

}

//Reset
bool Class1::ResetPosition()
{
	String^ buf1;
	String^ buf2;
	int i;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "R:D";
			for (i = 0; i <= 2; i++)
			{
				if (Module1::pCheckBoxEnable[i]->Checked == true)
				{
					buf1 = buf1 + "," + (i + 1).ToString();
				}
			}
			this->serialPort1->WriteLine(buf1);				//Send L command
			Threading::Thread::Sleep(50);
			buf2 = this->Get_Value(Module1::DeviceCount);	//Recive OK

			Threading::Thread::Sleep(1000);
			this->Wait_Ready();
		}
		else
		{
			throw new exception;
		}
	}
	catch (...)
	{
		return false;
	}
	return true;
}

//JOG
bool Class1::JOG(bool Dir)
{
	String^ buf1;
	String^ buf2;
	int i;
	String^ dirStr;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "J:D";
			if (Dir == true)
			{
				dirStr = "+";
			}
			else
			{
				dirStr = "-";
			}
			for (i = 0; i <= 2; i++)
			{
				if(Module1::pCheckBoxEnable[i]->Checked == true)
				{
					buf1 = buf1 + "," + (i + 1).ToString() + "," + dirStr;
				}
			}
			this->serialPort1->WriteLine(buf1);				//Send J command
			Threading::Thread::Sleep(50);
			buf2 = "";
			buf2 = this->serialPort1->ReadLine();			//Recive
			i = 4 + (2 * (Module1::DeviceCount - 1));
			buf1 = buf2->Substring(i, 2);
			if (buf1 != "OK")
			{
				throw new exception;
			}

			Threading::Thread::Sleep(500);
			this->Wait_Ready();		//Show current position
		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		return false;
	}
	return true;
}

//Move
bool Class1::Move(int Value[])
{
	String^ buf1;
	String^ buf2;
	int i;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "M:D";
			for (i = 0; i <= 2; i++)
			{
				if (Module1::pCheckBoxEnable[i]->Checked == true)
				{
					buf1 = buf1 + "," + (i + 1).ToString() + "," + Value[i].ToString();
				}
			}
			this->serialPort1->WriteLine(buf1);				//Send M command
			Threading::Thread::Sleep(50);

			buf2 = "";
			buf2 = this->serialPort1->ReadLine();			//Recive
			i = 4 + (2 * (Module1::DeviceCount - 1));
			buf1 = buf2->Substring(i, 2);
			if (buf1 != "OK")
			{
				throw new exception;
			}

			Threading::Thread::Sleep(1000);
			this->Wait_Ready();		//Show current position
		}
		else
		{
			throw new exception;
		}
		
	}
	catch (...)
	{
		return false;
	}
	return true;
}

//Move Absolute
bool Class1::MoveAbs(int Value[])
{
	String^ buf1;
	String^ buf2;
	int i;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "A:D";
			for (i = 0; i <= 2; i++)
			{
				if (Module1::pCheckBoxEnable[i]->Checked == true)
				{
					buf1 = buf1 + "," + (i + 1).ToString() + "," + Value[i].ToString();
				}
			}
			this->serialPort1->WriteLine(buf1);				//Send A command
			Threading::Thread::Sleep(50);

			buf2 = "";
			buf2 = this->serialPort1->ReadLine();			//Recive
			i = 4 + (2 * (Module1::DeviceCount - 1));
			buf1 = buf2->Substring(i, 2);
			if (buf1 != "OK")
			{
				throw new exception;
			}

			Threading::Thread::Sleep(1000);
			this->Wait_Ready();		//Show current position
		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		return false;
	}
	return true;
}



//Get B/R
String^ Class1::GetBR(int Axis)
{
	String^ buf1;
	String^ buf2;
	String^ buf3;
	char del = ',';
	std::string str;
	string sss[30];
	int j;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "!:D," + Axis.ToString();
			this->serialPort1->WriteLine(buf1);					//Send ! command
			Threading::Thread::Sleep(50);
			buf2 = this->serialPort1->ReadLine();			//Recive
			MarshalString(buf2, str);
			j = 0;
			for (const auto subStr : split(str, del)) {
				sss[j] = subStr;
				j += 1;
			}
			buf3 = gcnew String(sss[2].c_str());				//ACK3

		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		return "";
	}
	return buf3;
}

//Get Position
String^ Class1::GetPosition(int Axis)
{
	String^ buf1;
	String^ buf2;
	String^ buf3;
	char del = ',';
	std::string str;
	string sss[30];
	int j;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "Q:D," + Axis.ToString();
			this->serialPort1->WriteLine(buf1);					//Send ! command
			Threading::Thread::Sleep(50);
			buf2 = this->serialPort1->ReadLine();			//Recive
			MarshalString(buf2, str);
			j = 0;
			for (const auto subStr : split(str, del)) {
				sss[j] = subStr;
				j += 1;
			}
			buf3 = gcnew String(sss[2].c_str());				//Position

		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		return "";
	}
	return buf3;
}


