#include "Class1.h"
#include "Module1.h"
#include<string>
#include <stdio.h>
#include <stdlib.h>

#include <iostream>
#include <vector>
#include <cstdlib> 

using namespace SG_SDK_SHRC_HIT_CPP;
using namespace System;
using namespace std;

Class1::Class1()
{
	this->serialPort1->PortName = "COM3";
	this->serialPort1->BaudRate = 38400;
	this->serialPort1->Parity = System::IO::Ports::Parity::None;
	this->serialPort1->DataBits = 8;
	this->serialPort1->StopBits = System::IO::Ports::StopBits::One;
	this->serialPort1->Handshake = System::IO::Ports::Handshake::None;
	this->serialPort1->NewLine = "\r\n";
}

void MarshalString(String ^ s, string& os) {
	using namespace Runtime::InteropServices;
	const char* chars =
		(const char*)(Marshal::StringToHGlobalAnsi(s)).ToPointer();
	os = chars;
	Marshal::FreeHGlobal(IntPtr((void*)chars));
}


std::vector<std::string> split(std::string str, char del) {
	unsigned int first = 0;
	int last = str.find_first_of(del);

	std::vector<std::string> result;

	while (first < str.size()) {
		std::string subStr(str, first, last - first);

		result.push_back(subStr);

		first = last + 1;
		last = str.find_first_of(del, first);

		if (last == std::string::npos) {
			last = str.size();
		}
	}

	return result;
}

//Get Axis count
bool Class1::GetAxisCnt()
{
	String^ buf1 = "?:AXIS";
	String^ buf2;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			this->serialPort1->WriteLine(buf1);		//Send ?:AXIS
			Threading::Thread::Sleep(50);
			buf2 = this->serialPort1->ReadLine();	//Recive
			Module1::AxisCount = Int32::Parse(buf2);
		}
		else
		{
			throw new exception;
		}
	}
	catch (...)
	{
		Module1::AxisCount = -1;
		return false;
	}
	return true;
}

//Connect
bool Class1::Connect()
{
	String^ buf1 = "*IDN?";
	String^ buf2;
	String^ buf3;

	try
	{
		if (this->serialPort1->IsOpen == false)
		{
			this->serialPort1->Open();				//Port Open
			this->serialPort1->WriteLine(buf1);		//Send *IDN?
			Threading::Thread::Sleep(50);
			buf2 = this->serialPort1->ReadLine();	//Recive
			buf3 = buf2->Substring(10, 8);
			if (buf3 != "SHRC-203")					//Check the recive data
			{
				throw new exception;

			}
			if (GetAxisCnt() == false)				//Get AxisCount
			{
				throw new exception;
			}

			this->Wait_Ready();						//Show current position
		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		this->serialPort1->Close();		
		return false;
	}
	return true;
}

//Disconnect
bool Class1::Disconnect()
{
	try
	{
		this->serialPort1->Close();	//Port Close
	}
	catch (...)
	{
		return false;
	}
	return true;
}

//Get Speed
bool Class1::GetSpeed(String^& speed)

{
	String^ buf1;
	String^ buf2;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "?:D";
			this->serialPort1->WriteLine(buf1);		//Send ? command
			Threading::Thread::Sleep(50);
			buf2 = this->serialPort1->ReadLine();	//Recive
			speed = buf2;

		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		speed = "";
		return false;
	}
	return true;
}

//Wait to Ready
bool Class1::Wait_Ready()
{
	String^ buf1;
	String^ buf2;
	char del = ',';
	std::string str;
	std::string sss[30];
	int i, j;

	String^ buf3;
	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			WR_Doing = true;
			do
			{
				System::Windows::Forms::Application::DoEvents();
				if (Stop_Flg == true)
				{
					this->serialPort1->DiscardInBuffer();	//Clear buffer
					buf2 = Module1::GetAxisEnable();
					buf1 = "L:" + buf2;
					this->serialPort1->WriteLine(buf1);		//Send L command
					Threading::Thread::Sleep(50);
					buf2 = this->serialPort1->ReadLine();	//Recive
					if (buf2->IndexOf("OK") < 0)
					{
						throw new exception;
					}
					break;
				}

				this->serialPort1->DiscardInBuffer();		//Clear buffer
				buf1 = "Q:";
				this->serialPort1->WriteLine(buf1);			//Send Q command
				Threading::Thread::Sleep(100);
				buf3 = "";
				buf3 = this->serialPort1->ReadLine();		//Recive
				MarshalString(buf3, str);
				j = 0;
				for (const auto subStr : split(str, del)) {
					sss[j] = subStr;
					j += 1;
				}
				j = 0;
				for (i = 0; i <= 2; i++)
				{
					if (Module1::pCheckBoxEnable[i]->Checked == true)
					{
						Module1::pLabel_Position[i]->Text = gcnew String(sss[j].c_str());
						j += 1;
					}
				}

				System::Windows::Forms::Application::DoEvents();
				buf1 = "!:";
				this->serialPort1->WriteLine(buf1);		//Send ! command
				Threading::Thread::Sleep(50);
				buf2 = "";
				buf2 = this->serialPort1->ReadLine();	//Recive
				MarshalString(buf2, str);
				j = 0;
				for (const auto subStr : split(str, del)) {
					sss[j] = subStr;
					j += 1;
				}
				j = 0;
				for (i = 0; i <= 2; i++)
				{
					if (sss[i] == "")
					{
						continue;
					}
					if (sss[i] == "1" )
					{
						j = j + 1;
					}
				}
				if (j == 0)
				{
					return true;
				}
								

			} while (true);

		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		return false;
	}
	finally
	{
		Stop_Flg = false;
		WR_Doing = false;
	}
	return true;
}

//Set Speed
bool Class1::SetSpeed(std::string Speed[])
{
	String^ buf1;
	String^ buf2;
	int i;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "D:";
			for (i = 0; i <= 2; i++)
			{
				if (Module1::pCheckBoxEnable[i]->Checked == true)
				{
					buf1 = buf1 +(i+1).ToString()+"," + gcnew String(Speed[0].c_str()) + "," + gcnew String(Speed[1].c_str()) + "," + gcnew String(Speed[2].c_str());
				}
				this->serialPort1->WriteLine(buf1);		//Send D command
				Threading::Thread::Sleep(50);
				buf2 = this->serialPort1->ReadLine();	//Recive
				if (buf2->IndexOf("OK") < 0)
				{
					throw new exception;
				}
				Threading::Thread::Sleep(50);
				buf1 = "D:";
			}

		}
		else
		{
			throw new exception;
		}
	}
	catch (...)
	{
		return false;
	}
	return true;
}

//Return Origin
bool Class1::ReturnOrigin()
{
	String^ buf1;
	String^ buf2;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "H:" + Module1::GetAxisEnable();
			this->serialPort1->WriteLine(buf1);		//Send H command
			Threading::Thread::Sleep(50);
			buf2 = this->serialPort1->ReadLine();	//Recive
			if (buf2->IndexOf("OK") < 0)
			{
				throw new exception;
			}
			Threading::Thread::Sleep(50);
			this->Wait_Ready();		//Show current position
		}
		else
		{
			throw new exception;
		}
	}
	catch (...)
	{
		return false;
	}
	return true;
}

//Stop
bool Class1::StopStage()
{
	String^ buf1;
	String^ buf2;

	if (WR_Doing == true)	//Already doing
	{
		Stop_Flg = true;
		return true;
	}

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "L:" + Module1::GetAxisEnable();
			this->serialPort1->WriteLine(buf1);		//Send L command
			Threading::Thread::Sleep(50);
			buf2 = this->serialPort1->ReadLine();	//Recive
			if (buf2->IndexOf("OK") < 0)
			{
				throw new exception;
			}
			Threading::Thread::Sleep(50);
			this->Wait_Ready();		//Show current position
		}
		else
		{
			throw new exception;
		}
	}
	catch (...)
	{
		return false;
	}
	return true;
}

//Stop Emergency
bool Class1::StaopStageEmergency()
{
	String^ buf1;
	String^ buf2;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "L:E";
			this->serialPort1->WriteLine(buf1);		//Send L command
			Threading::Thread::Sleep(50);
			buf2 = this->serialPort1->ReadLine();	//Recive
			if (buf2->IndexOf("OK") < 0)
			{
				throw new exception;
			}
			Threading::Thread::Sleep(50);
			this->Wait_Ready();		//Show current position
		}
		else
		{
			throw new exception;
		}
	}
	catch (...)
	{
		return false;
	}
	return true;

}

//Reset
bool Class1::ResetPosition()
{
	String^ buf1;
	String^ buf2;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "R:" + Module1::GetAxisEnable();
			this->serialPort1->WriteLine(buf1);		//Send R command
			Threading::Thread::Sleep(50);
			buf2 = this->serialPort1->ReadLine();	//Recive
			if (buf2->IndexOf("OK") < 0)
			{
				throw new exception;
			}
			Threading::Thread::Sleep(50);
			this->Wait_Ready();		//Show current position

		}
		else
		{
			throw new exception;
		}
	}
	catch (...)
	{
		return false;
	}
	return true;
}

//JOG
bool Class1::JOG(bool Dir)
{
	String^ buf1;
	String^ buf2;
	string dirStr;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 =  Module1::GetAxisEnable();
			if (Dir == true)
			{
				dirStr = "+";
			}
			else
			{
				dirStr = "-";
			}
			buf1 = buf1->Replace("1", gcnew String(dirStr.c_str()));
			buf1 = buf1->Replace("0", "");
			buf1 = "J:" + buf1;
			this->serialPort1->WriteLine(buf1);		//Send J command
			Threading::Thread::Sleep(50);
			buf2 = "";
			buf2 = this->serialPort1->ReadLine();	//Recive
			if (buf2->IndexOf("OK") < 0)
			{
				throw new exception;
			}

			this->Wait_Ready();		//Show current position
		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		return false;
	}
	return true;
}

//Move
bool Class1::Move(int Value[])
{
	String^ buf1;
	String^ buf2;
	int i;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "M:";
			for (i = 0; i <= 2; i++)
			{
				if (Module1::pCheckBoxEnable[i]->Checked == true)
				{
					buf1 = buf1 + Value[i].ToString();
					if (i < 2)
					{
						buf1 = buf1 + ",";
					}
				}
				else
				{
					if (i < 2)
					{
						buf1 = buf1 + ",";
					}
				}
			}
			this->serialPort1->WriteLine(buf1);		//Send M command
			Threading::Thread::Sleep(50);
			buf2 = "";
			buf2 = this->serialPort1->ReadLine();	//Recive
			if (buf2->IndexOf("OK") < 0)
			{
				throw new exception;
			}

			this->Wait_Ready();		//Show current position

		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		return false;
	}
	return true;
}

//Move Absolute
bool Class1::MoveAbs(int Value[])
{
	String^ buf1;
	String^ buf2;
	int i;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "A:";
			for (i = 0; i <= 2; i++)
			{
				if (Module1::pCheckBoxEnable[i]->Checked == true)
				{
					buf1 = buf1 + Value[i].ToString();
					if (i < 2)
					{
						buf1 = buf1 + ",";
					}
				}
				else
				{
					if (i < 2)
					{
						buf1 = buf1 + ",";
					}
				}
			}
			this->serialPort1->WriteLine(buf1);		//send A command
			Threading::Thread::Sleep(50);
			buf2 = "";
			buf2 = this->serialPort1->ReadLine();	//Recive
			if (buf2->IndexOf("OK") < 0)
			{
				throw new exception;
			}

			this->Wait_Ready();		//Show current position

		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		return false;
	}
	return true;
}



//Get B/R	Axis = 1 - 3
String^ Class1::GetBR(int Axis)
{
	String^ buf1;
	String^ buf2;
	String^ st;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "!:" + Axis.ToString();
			this->serialPort1->WriteLine(buf1);		//Send ! command
			Threading::Thread::Sleep(50);
			buf2 = "";
			buf2 = this->serialPort1->ReadLine();	//Recive
			if (buf2 == "0")
			{
				st = "R";
			}
			else
			{
				st = "B";
			}

		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		return "";
	}
	return st;
}


//Get Position	Axis = 1 - 3
String^ Class1::GetPosition(int Axis)
{
	String^ buf1;
	String^ buf2;
	char del = ',';
	std::string str;
	string sss[30];
	int j;
	String^ st;

	try
	{
		if (this->serialPort1->IsOpen == true)
		{
			buf1 = "Q:";
			this->serialPort1->WriteLine(buf1);			//Send Q command
			Threading::Thread::Sleep(50);
			buf2 = "";
			buf2 = this->serialPort1->ReadLine();		//Recive
			MarshalString(buf2, str);
			j = 0;
			for (const auto subStr : split(str, del)) {
				sss[j] = subStr;
				j += 1;
			}
			st = gcnew String(sss[Axis - 1].c_str());	//Position

		}
		else
		{
			throw new exception;
		}

	}
	catch (...)
	{
		return "";
	}
	return st;
}












