﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SG_SDK_SBIS_CS
{
    public class Class1
    {

        public System.IO.Ports.SerialPort SerialPort1 = new System.IO.Ports.SerialPort();
        
        public bool Stop_Flg = false;
        public bool WR_Doing = false;

        public Class1()
            {
            SerialPort1.PortName = "COM1";
            SerialPort1.BaudRate = 38400;
            SerialPort1.Parity = System.IO.Ports.Parity.None;
            SerialPort1.DataBits = 8;
            SerialPort1.StopBits = System.IO.Ports.StopBits.One;
            SerialPort1.Handshake = System.IO.Ports.Handshake.None;
            SerialPort1.NewLine = "\r\n";
            }
  
        // Connect
        public bool Connect()
        {
            string buf;
            string[] data;
            
            try
            {
                if (SerialPort1.IsOpen == false)
                {
                    SerialPort1.Open();                              // Port Open
                    SerialPort1.WriteLine("#CONNECT:");              // Send #CONNECT:
                    System.Threading.Thread.Sleep(50);
                    buf = SerialPort1.ReadLine();                    // Recive
                    data = buf.Split(',');                           // Check the recive data
                    if (data[0] != "OK")
                        throw new Exception();
                    Module1.DeviceCount = System.Convert.ToInt32(data[1]);   // Device count

                    Wait_Ready();  // Show current position
                }
            }
            catch 
            {
                SerialPort1.Close();
                return false;
            }
            return true;
        }

        // Disconnect
        public bool Disconnect()
        {
            try
            {
                SerialPort1.Close();    //Port Close
            }
            catch 
            {
                return false;
            }
            return true;
        }

        // Get Speed
        public bool GetSpeed(int DevNo, ref string Speed)
        {
            string buf, buf2;
            string[] spd;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "?:D," + (DevNo).ToString() + ",D";
                    SerialPort1.WriteLine(buf);  // Send ?command
                    System.Threading.Thread.Sleep(50);
                    buf2 = SerialPort1.ReadLine(); // Recive

                    spd = buf2.Split(',');
                    buf = "S" + spd[0] + "F" + spd[1] + "R" + spd[2];
                    Speed = buf;
                }
                else
                    throw new Exception();
            }
            catch
            {
                Speed = "";
                return false;
            }
            return true;
        }

        // Get recive data
        private string Get_Value(int Num)
        {
            string buf = "";
            string[] str;
            string rtn = "";
            int i;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    for (i = 1; i <= Num; i++)
                    {
                        System.Windows.Forms.Application.DoEvents();
                        buf = SerialPort1.ReadLine();   //Recive
                        buf = buf.TrimEnd();
                        str = buf.Split(',');
                        rtn = rtn + str[2];
                        if (Num != 1 && i != Num)
                            rtn = rtn + ",";
                        System.Threading.Thread.Sleep(50);
                    }
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return "";
            }
            return rtn;
        }

        // Wait to Ready 
        public bool Wait_Ready()
        {
            string buf, buf2;
            string[] value = null;
            int i, j;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    do
                    {
                        WR_Doing = true;
                        System.Windows.Forms.Application.DoEvents();
                        if (Stop_Flg == true)
                        {
                            SerialPort1.DiscardInBuffer();  //Clear buffer
                            buf = "LE:A";
                            SerialPort1.WriteLine(buf);     //Send LE:A command
                            System.Threading.Thread.Sleep(50);
                            buf2 = this.Get_Value(Module1.DeviceCount); //Recice OK
                            break;
                        }

                        SerialPort1.DiscardInBuffer();  //Clear buffer
                        buf = "Q:A";
                        SerialPort1.WriteLine(buf);     //Send Q command
                        System.Threading.Thread.Sleep(50);
                        buf2 = this.Get_Value(Module1.DeviceCount); //Recive coordinate
                        value = buf2.Split(',');
                        j = 0;
                        for (i = 0; i <= 2; i++)
                        {
                            if (Module1.pCheckBoxEnable[i].Checked == true)
                            {
                                Module1.pLabel_Position[i].Text = value[j]; //Show coordinate
                                j = j + 1;
                            }
                        }

                        System.Windows.Forms.Application.DoEvents();
                        SerialPort1.DiscardInBuffer();  //Clear buffer
                        buf = "!:A";
                        SerialPort1.WriteLine(buf);     //Send ! command
                        System.Threading.Thread.Sleep(50);
                        buf2 = this.Get_Value(Module1.DeviceCount); //Recive status
                        value = buf2.Split(',');
                        j = 0;
                        for (i = 0; i <= Module1.DeviceCount - 1; i++)
                        {
                            if (value[i] == "R")    //Check Ready
                                j = j + 1;
                        }

                        if (j == Module1.DeviceCount)
                            break;
                    }
                    while (true);
                        
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            finally
            {
                Stop_Flg = false;
                WR_Doing = false;
            }
            return true;
        }

        // Retrun Origin
        public bool ReturnOrigin()
        {
            string buf, buf2;
            int i;
            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "H:D";
                    buf2 = Module1.DeviceString();
                    if (buf2 == "")
                        throw new Exception();
                    buf = buf + buf2;

                    SerialPort1.WriteLine(buf);  // Send H command
                    System.Threading.Thread.Sleep(50);
                    buf2 = "";
                    buf2 = SerialPort1.ReadLine();
                    i = 4 + (2 * (Module1.DeviceCount - 1));
                    buf = buf2.Substring(i, 2);
                    if (buf != "OK") throw new Exception(); //Check OK

                    System.Threading.Thread.Sleep(2500);
                    Wait_Ready();  // Show current position
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            return true;
        }

        // Set Speed
        public bool SetSpeed(string[] Speed)
        {
            int i;
            string buf, buf2;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "D:D";
                    for (i = 0; i <= 2; i++)
                    {
                        if (Module1.pCheckBoxEnable[i].Checked == true)
                            buf = buf + "," + (i + 1).ToString() + "," + Speed[0] + "," + Speed[1] + "," + Speed[2];
                    }
                    SerialPort1.WriteLine(buf);  // Send D command
                    System.Threading.Thread.Sleep(50);
                    buf2 = this.Get_Value(Module1.DeviceCount);  // Recive OK
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            return true;
        }

        // Stop
        public bool StopStage()
        {
            int i;
            string buf, buf2;

            if (WR_Doing == true)   //Already doing
            {
                Stop_Flg = true;
                return true;
            }

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "L:D";
                    for (i = 0; i <= 2; i++)
                    {
                        if (Module1.pCheckBoxEnable[i].Checked == true)
                            buf = buf + "," + (i + 1).ToString();
                    }
                    SerialPort1.WriteLine(buf);  // Send L command
                    System.Threading.Thread.Sleep(50);
                    buf2 = this.Get_Value(Module1.DeviceCount);  // Recive OK
                   
                    System.Threading.Thread.Sleep(1500);
                    Wait_Ready();  // Show current position
                }
                else
                    throw new Exception();
            }
            catch
            {
                return false;
            }
            return true;
        }

        // Stop Emergency
        public bool StopStageEmergency()
        {
            string buf, buf2;
            int i;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "EL:A";
                    SerialPort1.WriteLine(buf);  // Send L command
                    System.Threading.Thread.Sleep(50);
                    buf2 = this.Get_Value(Module1.DeviceCount);  // Recive OK

                    System.Threading.Thread.Sleep(2500);
                    Wait_Ready();  // Show current position
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            return true;
        }

        // Reset
        public bool ResetPosition()
        {
            int i;
            string buf, buf2;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "R:D";
                    for (i = 0; i <= 2; i++)
                    {
                        if (Module1.pCheckBoxEnable[i].Checked == true)
                            buf = buf + "," + (i + 1).ToString();
                    }
                    SerialPort1.WriteLine(buf);  // Send L command
                    System.Threading.Thread.Sleep(50);
                    buf2 = this.Get_Value(Module1.DeviceCount);  // Recive OK
 
                    System.Threading.Thread.Sleep(1000);
                    Wait_Ready();  // Show current position
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            return true;
        }

        // JOG
        public bool JOG(bool Dir)
        {
            int i;
            string buf, buf2;
            string dirStr;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "J:D";
                    if (Dir == true)
                        dirStr = "+";
                    else
                        dirStr = "-";
                    for (i = 0; i <= 2; i++)
                    {
                        if (Module1.pCheckBoxEnable[i].Checked == true)
                            buf = buf + "," + (i + 1).ToString() + "," + dirStr;
                    }
                    SerialPort1.WriteLine(buf);  // Send J command
                    System.Threading.Thread.Sleep(50);
                    buf2 = "";
                    buf2 = SerialPort1.ReadLine();
                    i = 4 + (2 * (Module1.DeviceCount - 1));
                    buf = buf2.Substring(i, 2);
                    if (buf != "OK") throw new Exception(); //Check OK

                    System.Threading.Thread.Sleep(500);
                    Wait_Ready();  // Show current position
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            return true;
        }

        // Move
        public bool Move(int[] Value)
        {
            int i;
            string buf, buf2;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "M:D";
                    for (i = 0; i <= 2; i++)
                    {
                        if (Module1.pCheckBoxEnable[i].Checked == true)
                            buf = buf + "," + (i + 1).ToString() + "," + Value[i].ToString();
                    }
                    SerialPort1.WriteLine(buf);  // Send M command
                    System.Threading.Thread.Sleep(50);
                    buf2 = "";
                    buf2 = SerialPort1.ReadLine();
                    i = 4 + (2 * (Module1.DeviceCount - 1));
                    buf = buf2.Substring(i, 2);
                    if (buf != "OK") throw new Exception(); //Check OK

                    System.Threading.Thread.Sleep(1000);
                    Wait_Ready();  // Show current position
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            return true;
        }

        // Move Absolute
        public bool MoveAbs(int[] Value)
        {
            int i;
            string buf, buf2;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "A:D";
                    for (i = 0; i <= 2; i++)
                    {
                        if (Module1.pCheckBoxEnable[i].Checked == true)
                            buf = buf + "," + (i + 1).ToString() + "," + Value[i].ToString();
                    }
                    SerialPort1.WriteLine(buf);  // Send A command
                    System.Threading.Thread.Sleep(50);
                    buf2 = "";
                    buf2 = SerialPort1.ReadLine();
                    i = 4 + (2 * (Module1.DeviceCount - 1));
                    buf = buf2.Substring(i, 2);
                    if (buf != "OK") throw new Exception(); //Check OK

                    System.Threading.Thread.Sleep(1000);
                    Wait_Ready();  // Show current position
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            return true;
        }


        // Get B/R 
        public string GetBR(int Axis)
        {
            string buf, buf2, buf3;
            string[] value = null;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "!:D," + Axis.ToString();
                    SerialPort1.WriteLine(buf);     //Send ! command
                    System.Threading.Thread.Sleep(50);
                    buf2 = SerialPort1.ReadLine();  //Recive Status
                    value = buf2.Split(',');
                    buf3 = value[2];                //ACK3
                }
                else
                    throw new Exception();
            }
            catch
            {
                return "";
            }
            return buf3;
        }

        // Get Position 
        public string GetPosition(int Axis)
        {
            string buf, buf2, buf3;
            string[] value = null;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "Q:D," + Axis.ToString();
                    SerialPort1.WriteLine(buf);     //Send ! command
                    System.Threading.Thread.Sleep(50);
                    buf2 = SerialPort1.ReadLine();  //Recive Status
                    value = buf2.Split(',');
                    buf3 = value[2];                //Position
                }
                else
                    throw new Exception();
            }
            catch
            {
                return "";
            }
            return buf3;
        }




    }
}
