﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SG_SDK_SHRC_HIT_CS
{
    public class Class1
    {
        public System.IO.Ports.SerialPort SerialPort1 = new System.IO.Ports.SerialPort();

        public bool Stop_Flg = false;
        public bool WR_Doing = false;

        public Class1()
        {
            SerialPort1.PortName = "COM4";
            SerialPort1.BaudRate = 38400;
            SerialPort1.Parity = System.IO.Ports.Parity.None;
            SerialPort1.DataBits = 8;
            SerialPort1.StopBits = System.IO.Ports.StopBits.One;
            SerialPort1.Handshake = System.IO.Ports.Handshake.None;
            SerialPort1.NewLine = "\r\n";
        }

        // Connect
        public bool Connect()
        {
            string buf;
            string[] data;

            try
            {
                if (SerialPort1.IsOpen == false)
                {
                    SerialPort1.Open();                              // Port Open
                    SerialPort1.WriteLine("*IDN?");                  // Send *IDN?
                    System.Threading.Thread.Sleep(50);
                    buf = SerialPort1.ReadLine();                    // Recive
                    data = buf.Split(',');                           // Check the recive data
                    if (data[1] != "SHRC-203")
                        throw new Exception();

                    if (GetAxisCnt() == false)
                        throw new Exception();    // Get AxisCount

                    Wait_Ready();  // Show current position
                }
            }
            catch
            {
                SerialPort1.Close();
                return false;
            }
            return true;
        }

        // Disconnect
        public bool Disconnect()
        {
            try
            {
                SerialPort1.Close();    //Port Close
            }
            catch
            {
                return false;
            }
            return true;
        }

        // Axis count
        public bool GetAxisCnt()
        {
            string buf;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    SerialPort1.WriteLine("?:AXIS");              // Send ?:AXIS
                    System.Threading.Thread.Sleep(50);
                    buf = SerialPort1.ReadLine();                 // Recive
                    Module1.AxisCount = System.Convert.ToInt32(buf.Substring(0, 1));
                }
                else
                    throw new Exception();
            }
            catch
            {
                Module1.AxisCount = -1;
                return false;
            }
            return true;
        }

        // Get Speed
        public bool Get_Speed(ref string Speed)
        {
            string buf, buf2;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "?:D";
                    SerialPort1.WriteLine(buf);      // Send ? command
                    System.Threading.Thread.Sleep(50);
                    buf2 = SerialPort1.ReadLine();   // Recive
                    Speed = buf2;
                }
                else
                    throw new Exception();
            }
            catch
            {
                return false;
            }
            return true;
        }

        // Wait to Ready
        public bool Wait_Ready()
        {
            int i,j;
            string st = "";
            string buf, buf2;
            string[] buf3 = null;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    WR_Doing = true;
                    do
                    {
                        System.Windows.Forms.Application.DoEvents();
                        if (Stop_Flg == true)
                        {
                            SerialPort1.DiscardInBuffer();      //Clear buffer
                            if (Module1.GetAxisEnable(ref st) == false)
                                throw new Exception();
                            buf = "L:" + st;
                            SerialPort1.WriteLine(buf);         //Send L command
                            System.Threading.Thread.Sleep(50);
                            buf2 = SerialPort1.ReadLine();      //Recive
                            if ((buf2.ToUpper()).IndexOf("OK") < 0)
                                throw new Exception();
                            break;
                        }

                        SerialPort1.DiscardInBuffer();          //Clear buffer
                        SerialPort1.WriteLine("Q:");            //Send Q command
                        System.Threading.Thread.Sleep(50);
                        buf = SerialPort1.ReadLine();           //Recive
                        buf3 = buf.Split(',');
                        for (i = 0; i <= 2; i++)
                            Module1.pLabel_Position[i].Text = buf3[i];
                        System.Windows.Forms.Application.DoEvents();
                        SerialPort1.WriteLine("!:");            //Send ! command
                        System.Threading.Thread.Sleep(50);
                        buf = SerialPort1.ReadLine();           //Recive
                        buf3 = buf.Split(',');
                        j = 0;
                        for (i = 0; i <= 2; i++)
                        {
                             if (buf3[i] != "0")
                                j = j + 1;
                        }
                        if (j == 0)
                            return true;
                    }
                    while (true);
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            finally
            {
                Stop_Flg = false;
                WR_Doing = false;
            }
            return true;
        }

        // Set Speed
        public bool SetSpeed(string[] Speed)
        {
            int i;
            string buf, buf2;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "D:";
                    for (i = 0; i <= 2; i++)
                    {
                        if (Module1.pCheckBoxEnable[i].Checked == true)
                        {
                            buf = buf + (i + 1).ToString() + "," + Speed[0] + "," + Speed[1] + "," + Speed[2];
                            SerialPort1.WriteLine(buf);     // Send D command
                            System.Threading.Thread.Sleep(50);
                            buf2 = SerialPort1.ReadLine();  // Recive
                            if ((buf2.ToUpper()).IndexOf("OK") < 0)
                                throw new Exception();
                            System.Threading.Thread.Sleep(50);
                            buf = "D:";
                        }
                    }
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            return true;
        }

        // Retrun Origin
        public bool ReturnOrigin()
        {
            string buf, buf2;
            string st = "";

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    if (Module1.GetAxisEnable(ref st) == false)
                        throw new Exception();
                    buf = "H:" + st;
                    SerialPort1.WriteLine(buf);     // Send H command
                    System.Threading.Thread.Sleep(50);
                    buf2 = SerialPort1.ReadLine();  // Recive
                    if ((buf2.ToUpper()).IndexOf("OK") < 0)
                        throw new Exception();
                    System.Threading.Thread.Sleep(50);
                    Wait_Ready();   // Show current position
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            return true;
        }

        // Stop
        public bool StopStage()
        {
            string buf, buf2;
            string st = "";

            if (WR_Doing == true)   //Already doing
            {
                Stop_Flg = true;
                return true;
            }
            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    if (Module1.GetAxisEnable(ref st) == false)
                        throw new Exception();
                    buf = "L:" + st;
                    SerialPort1.WriteLine(buf);     // Send L command
                    System.Threading.Thread.Sleep(50);
                    buf2 = SerialPort1.ReadLine();  // Recive
                    if ((buf2.ToUpper()).IndexOf("OK") < 0)
                        throw new Exception();
                    System.Threading.Thread.Sleep(50);
                    Wait_Ready();   // Show current position
                }
                else
                    throw new Exception();
            }
            catch
            {
                return false;
            }
            return true;
        }

        // Stop Emergency
        public bool StopStageEmergency()
        {
            string buf, buf2;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "L:E";
                    SerialPort1.WriteLine(buf);     // Send L command
                    System.Threading.Thread.Sleep(50);
                    buf2 = SerialPort1.ReadLine();  // Recive
                    if ((buf2.ToUpper()).IndexOf("OK") < 0)
                        throw new Exception();
                    System.Threading.Thread.Sleep(50);
                    Wait_Ready();   // Show current position
                }
                else
                    throw new Exception();
            }
            catch
            {
                return false;
            }
            return true;
        }

        // Reset
        public bool ResetPosition()
        {
            string buf, buf2;
            string st = "";

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    if (Module1.GetAxisEnable(ref st) == false)
                        throw new Exception();
                    buf = "R:" + st;
                    SerialPort1.WriteLine(buf);     // Send R command
                    System.Threading.Thread.Sleep(50);
                    buf2 = SerialPort1.ReadLine();  // Recive
                    if ((buf2.ToUpper()).IndexOf("OK") < 0)
                        throw new Exception();
                    System.Threading.Thread.Sleep(50);
                    Wait_Ready();   // Show current position
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            return true;
        }

        // JOG
        public bool JOG(bool Dir)
        {
            string buf, buf2;
            string dirStr;
            string st = "";

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    if (Module1.GetAxisEnable(ref st) == false)
                        throw new Exception();
                    if (Dir == true)
                        dirStr = "+";
                    else
                        dirStr = "-";
                    st = st.Replace("1", dirStr);
                    st = st.Replace("0", "");
                    buf = "J:" + st;
                    SerialPort1.WriteLine(buf);     // Send J command
                    System.Threading.Thread.Sleep(50);
                    buf2 = "";
                    buf2 = SerialPort1.ReadLine();  // Recive
                    if ((buf2.ToUpper()).IndexOf("OK") < 0)
                        throw new Exception();

                    Wait_Ready();   // Show current position
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            return true;
        }

        // Move
        public bool Move(int[] Value)
        {
            int i;
            string buf, buf2;
            string[] uuu = new string[3];

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "M:";
                    for (i = 0; i <= 2; i++)
                    {
                        if (Module1.pCheckBoxEnable[i].Checked == true)
                            buf = buf + Value[i].ToString();
                        if (i < 2)
                            buf = buf + ",";
                    }
                    SerialPort1.WriteLine(buf);     // Send M command
                    System.Threading.Thread.Sleep(50);
                    buf2 = "";
                    buf2 = SerialPort1.ReadLine();  // Recive
                    if ((buf2.ToUpper()).IndexOf("OK") < 0)
                        throw new Exception();

                    Wait_Ready();   // Show current position
                }
                else
                    throw new Exception();
            }
            catch 
            {
                return false;
            }
            return true;
        }

        // Move Absolute
        public bool MoveAbs(int[] Value)
        {
            int i;
            string buf, buf2;
            string[] uuu = new string[3];

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf = "A:";
                    for (i = 0; i <= 2; i++)
                    {
                        if (Module1.pCheckBoxEnable[i].Checked == true)
                            buf = buf + Value[i].ToString();
                        if (i < 2)
                            buf = buf + ",";
                    }
                    SerialPort1.WriteLine(buf);     // Send A command
                    System.Threading.Thread.Sleep(50);
                    buf2 = "";
                    buf2 = SerialPort1.ReadLine();  // Recive
                    if ((buf2.ToUpper()).IndexOf("OK") < 0)
                        throw new Exception();

                    Wait_Ready();   // Show current position
                }
                else
                    throw new Exception();
            }
            catch
            {
                return false;
            }
            return true;
        }


        // Get B/R  Axis = 1 - 3
        public string GetBR(int Axis)
        {
            string st = "";
            string buf1, buf2;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf1 = "!:" + Axis.ToString();
                    SerialPort1.WriteLine(buf1);            //Send ! command
                    System.Threading.Thread.Sleep(50);
                    buf2 = SerialPort1.ReadLine();           //Recive
                    if (buf2 == "0")
                    {
                        st = "R";
                    }
                    else
                    {
                        st = "B";
                    }
                }
                else
                    throw new Exception();
            }
            catch
            {
                return "";
            }
            return st;
        }

        // Get Position  Axis = 1 - 3
        public string GetPosition(int Axis)
        {
            string st = "";
            string buf1, buf2;
            string[] buf3 = null;

            try
            {
                if (SerialPort1.IsOpen == true)
                {
                    buf1 = "Q:";
                    SerialPort1.WriteLine(buf1);            //Send Q command
                    System.Threading.Thread.Sleep(50);
                    buf2 = SerialPort1.ReadLine();           //Recive
                    buf3 = buf2.Split(',');
                    st = buf3[Axis - 1];                    //Position
                }
                else
                    throw new Exception();
            }
            catch
            {
                return "";
            }
            return st;
        }

        

    }
}
