﻿Public Class Class1
    Public SerialPort1 As New System.IO.Ports.SerialPort

    Public Stop_Flg As Boolean = False
    Public WR_Doing As Boolean = False

    Public Sub New()
        SerialPort1.PortName = "COM3"
        SerialPort1.BaudRate = 38400
        SerialPort1.Parity = IO.Ports.Parity.None
        SerialPort1.DataBits = 8
        SerialPort1.StopBits = 1
        SerialPort1.Handshake = IO.Ports.Handshake.None
        SerialPort1.NewLine = vbCrLf
    End Sub


    'Connect
    Public Function Connect() As Boolean
        Dim buf As String
        Dim data() As String

        Try
            If SerialPort1.IsOpen = False Then
                SerialPort1.Open()                              'Port Open
                SerialPort1.WriteLine("#CONNECT:")              'Send #CONNECT:
                Threading.Thread.Sleep(50)
                buf = SerialPort1.ReadLine()                    'Recive
                data = buf.Split(",")                           'Check the recive data
                If data(0) <> "OK" Then Throw New Exception
                DeviceCount = CInt(data(1))                     'Device count

                Wait_Ready()  'Show current position
            End If
        Catch ex As Exception
            SerialPort1.Close()
            Return False
        End Try
        Return True
    End Function

    'Disconnect
    Public Function Disconnect() As Boolean
        Try
            SerialPort1.Close() 'Pport Close 
        Catch ex As Exception
            Return False
        End Try
        Return True
    End Function

    'Get Speed
    Public Function GetSpeed(DevNo As Integer, ByRef Speed As String) As Boolean
        Dim buf, buf2 As String
        Dim spd() As String

        Try
            If SerialPort1.IsOpen = True Then
                buf = "?:D," + (DevNo).ToString + ",D"
                SerialPort1.WriteLine(buf)  'Send ? command
                Threading.Thread.Sleep(50)
                buf2 = SerialPort1.ReadLine 'Recive

                spd = buf2.Split(",")
                buf = "S" + spd(0) + "F" + spd(1) + "R" + spd(2)
                Speed = buf
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Speed = ""
            Return False
        End Try
        Return True
    End Function

    'Get recive data
    Private Function Get_Value(Num As Integer) As String
        Dim buf As String = ""
        Dim str() As String
        Dim rtn As String = ""
        Dim i As Integer

        Try
            If SerialPort1.IsOpen = True Then
                For i = 1 To Num
                    System.Windows.Forms.Application.DoEvents()
                    buf = SerialPort1.ReadLine  'Recive
                    buf = buf.TrimEnd
                    str = buf.Split(",")
                    rtn = rtn + str(2)
                    If Num <> 1 AndAlso i <> Num Then rtn = rtn + ","
                    Threading.Thread.Sleep(50)
                Next
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Return ""
        End Try
        Return rtn
    End Function

    'Wait to Ready 
    Public Function Wait_Ready() As Boolean
        Dim buf, buf2 As String
        Dim value() As String = Nothing
        Dim i, j As Integer

        Try
            If SerialPort1.IsOpen = True Then
                Do
                    WR_Doing = True
                    System.Windows.Forms.Application.DoEvents()
                    If Stop_Flg = True Then
                        SerialPort1.DiscardInBuffer()   'Clear buffer
                        buf = "LE:A"
                        SerialPort1.WriteLine(buf)  'Send LE:A command
                        Threading.Thread.Sleep(50)
                        buf2 = Me.Get_Value(DeviceCount)  'Recive OK
                        Exit Do
                    End If

                    SerialPort1.DiscardInBuffer()   'Clear buffer
                    buf = "Q:A"
                    SerialPort1.WriteLine(buf)  'Send Q command
                    Threading.Thread.Sleep(50)
                    buf2 = Me.Get_Value(DeviceCount)  'Recive coordinate
                    value = buf2.Split(",")
                    j = 0
                    For i = 0 To 2
                        If pCheckBoxEnable(i).Checked = True Then
                            pLabel_Position(i).Text = value(j)  'Show Coordinate
                            j = j + 1
                        End If
                    Next

                    System.Windows.Forms.Application.DoEvents()
                    SerialPort1.DiscardInBuffer()   'Clear buffer
                    buf = "!:A"
                    SerialPort1.WriteLine(buf)  'Send ! command
                    Threading.Thread.Sleep(50)
                    buf2 = Me.Get_Value(DeviceCount)  'Recive status
                    value = buf2.Split(",")
                    j = 0
                    For i = 0 To DeviceCount - 1
                        If value(i) = "R" Then j = j + 1 'Check Ready
                    Next
                    If j = DeviceCount Then Exit Do
                Loop While True
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Return False
        Finally
            Stop_Flg = False
            WR_Doing = False
        End Try
        Return True
    End Function

    'Retrun Origin
    Public Function ReturnOrigin() As Boolean
        Dim buf, buf2 As String
        Dim i As Integer
        Try
            If SerialPort1.IsOpen = True Then
                buf = "H:D"
                buf2 = DeviceString()
                If buf2 = "" Then Throw New Exception
                buf = buf + buf2
                SerialPort1.WriteLine(buf)  'Send H command
                Threading.Thread.Sleep(50)

                buf2 = ""
                buf2 = SerialPort1.ReadLine  'Recive
                i = 4 + (2 * (DeviceCount - 1))
                buf = buf2.Substring(i, 2)
                If buf <> "OK" Then Throw New Exception 'Check OK

                Threading.Thread.Sleep(2500)
                Wait_Ready()  'Show current position
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Return False
        End Try
        Return True
    End Function

    'Set Speed
    Public Function SetSpeed(Speed() As String) As Boolean
        Dim i As Integer
        Dim buf, buf2 As String

        Try
            If SerialPort1.IsOpen = True Then
                buf = "D:D"
                For i = 0 To 2
                    If pCheckBoxEnable(i).Checked = True Then
                        buf = buf + "," + (i + 1).ToString + "," + Speed(0) + "," + Speed(1) + "," + Speed(2)
                    End If
                Next
                SerialPort1.WriteLine(buf)  'Send D command
                Threading.Thread.Sleep(50)
                buf2 = Me.Get_Value(DeviceCount)  'Recive OK

            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Return False
        End Try
        Return True
    End Function

    'Stop
    Public Function StopStage() As Boolean
        Dim i As Integer
        Dim buf, buf2 As String

        If WR_Doing = True Then 'Already doing
            Stop_Flg = True
            Return True
        End If

        Try
            If SerialPort1.IsOpen = True Then
                buf = "L:D"
                For i = 0 To 2
                    If pCheckBoxEnable(i).Checked = True Then
                        buf = buf + "," + (i + 1).ToString
                    End If
                Next
                SerialPort1.WriteLine(buf)  'Send L command
                Threading.Thread.Sleep(50)
                buf2 = Me.Get_Value(DeviceCount)  'Recive OK

                Threading.Thread.Sleep(1500)
                Wait_Ready()  'Show current position
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Return False
        End Try
        Return True
    End Function

    'Stop Emergency
    Public Function StopStageEmergency() As Boolean
        Dim buf, buf2 As String
        Dim i As Integer

        Try
            If SerialPort1.IsOpen = True Then
                buf = "EL:A"
                SerialPort1.WriteLine(buf)  'Send L command
                Threading.Thread.Sleep(50)
                buf2 = Me.Get_Value(DeviceCount)  'Recive OK

                Threading.Thread.Sleep(2500)
                Wait_Ready()  'Show current position
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Return False
        End Try
        Return True
    End Function

    'Reset
    Public Function ResetPosition() As Boolean
        Dim i As Integer
        Dim buf, buf2 As String

        Try
            If SerialPort1.IsOpen = True Then
                buf = "R:D"
                For i = 0 To 2
                    If pCheckBoxEnable(i).Checked = True Then
                        buf = buf + "," + (i + 1).ToString
                    End If
                Next
                SerialPort1.WriteLine(buf)  'Send L command
                Threading.Thread.Sleep(50)
                buf2 = Me.Get_Value(DeviceCount)  'Recive OK

                Threading.Thread.Sleep(1000)
                Wait_Ready()  'Show current position
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Return False
        End Try
        Return True
    End Function

    'JOG
    Public Function JOG(Dir As Boolean) As Boolean
        Dim i As Integer
        Dim buf, buf2 As String
        Dim dirStr As String

        Try
            If SerialPort1.IsOpen = True Then
                buf = "J:D"
                If Dir = True Then
                    dirStr = "+"
                Else
                    dirStr = "-"
                End If
                For i = 0 To 2
                    If pCheckBoxEnable(i).Checked = True Then
                        buf = buf + "," + (i + 1).ToString + "," + dirStr
                    End If
                Next
                SerialPort1.WriteLine(buf)  'Send J command
                Threading.Thread.Sleep(50)
                buf2 = ""
                buf2 = SerialPort1.ReadLine  'Recive
                i = 4 + (2 * (DeviceCount - 1))
                buf = buf2.Substring(i, 2)
                If buf <> "OK" Then Throw New Exception 'Check OK

                Threading.Thread.Sleep(500)
                Wait_Ready()  'Show current position
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Return False
        End Try
        Return True
    End Function

    'Move
    Public Function Move(Value() As Integer) As Boolean
        Dim i As Integer
        Dim buf, buf2 As String

        Try
            If SerialPort1.IsOpen = True Then
                buf = "M:D"
                For i = 0 To 2
                    If pCheckBoxEnable(i).Checked = True Then
                        buf = buf + "," + (i + 1).ToString + "," + Value(i).ToString
                    End If
                Next
                SerialPort1.WriteLine(buf)  'Send M command
                Threading.Thread.Sleep(50)
                buf2 = ""
                buf2 = SerialPort1.ReadLine  'Recive
                i = 4 + (2 * (DeviceCount - 1))
                buf = buf2.Substring(i, 2)
                If buf <> "OK" Then Throw New Exception 'Check OK

                Threading.Thread.Sleep(1000)
                Wait_Ready()  'Show current position
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Return False
        End Try
        Return True
    End Function

    'Move Absolute
    Public Function MoveAbs(Value() As Integer) As Boolean
        Dim i As Integer
        Dim buf, buf2 As String

        Try
            If SerialPort1.IsOpen = True Then
                buf = "A:D"
                For i = 0 To 2
                    If pCheckBoxEnable(i).Checked = True Then
                        buf = buf + "," + (i + 1).ToString + "," + Value(i).ToString
                    End If
                Next
                SerialPort1.WriteLine(buf)  'Send A command
                Threading.Thread.Sleep(50)
                buf2 = ""
                buf2 = SerialPort1.ReadLine  'Recive
                i = 4 + (2 * (DeviceCount - 1))
                buf = buf2.Substring(i, 2)
                If buf <> "OK" Then Throw New Exception 'Check OK

                Threading.Thread.Sleep(1000)
                Wait_Ready()  'Show current position
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Return False
        End Try
        Return True
    End Function


    'Get B/R 
    Public Function GetBR(Axis As Integer) As String
        Dim buf, buf2, buf3 As String
        Dim value() As String = Nothing

        Try
            If SerialPort1.IsOpen = True Then
                buf = "!:D," + Axis.ToString
                SerialPort1.WriteLine(buf)  'Send ! command
                Threading.Thread.Sleep(50)
                buf2 = SerialPort1.ReadLine  'Recive status
                value = buf2.Split(",")
                buf3 = value(2)             'ACK3
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Return ""
        End Try
        Return buf3
    End Function

    'Get Position 
    Public Function GetPosition(Axis As Integer) As String
        Dim buf, buf2, buf3 As String
        Dim value() As String = Nothing

        Try
            If SerialPort1.IsOpen = True Then
                buf = "Q:D," + Axis.ToString
                SerialPort1.WriteLine(buf)  'Send ! command
                Threading.Thread.Sleep(50)
                buf2 = SerialPort1.ReadLine  'Recive status
                value = buf2.Split(",")
                buf3 = value(2)             'Position
            Else
                Throw New Exception
            End If
        Catch ex As Exception
            Return ""
        End Try
        Return buf3
    End Function

End Class
